boundLow = -0.5;
boundHigh = 0.5;
numholes = 0;
numtimesteps = 1000;
len = 100000;

[posx, posy, posz, angs3, angs2, angs1] = GetRandomFlight(boundLow, boundHigh, numholes, numtimesteps, len);
len = length(angs1);

rng('shuffle');
noisevar = 0;
varterm= 0.4;
alpha = 0.3;
dt= 1;
N = 10;
Rmin = 3;
inh = 0.05;
extinp = 1;
dtinv = 10;
tau = 10;

preferencefromsomewhere1 = zeros(N,N);
preferencefromsomewhere2 = zeros(N,N);

for i = 1:N
    for j = 1:N
            preferencefromsomewhere1(i,j) = i*2*pi/(N) - pi  + noisevar * normrnd(0,pi);
            preferencefromsomewhere2(i,j) = j*2*pi/(N) - pi  + noisevar * normrnd(0,pi);
    end
end

w1 = zeros(N*N,N*N);
for m = 1:N
    for n = 1:N
        for j = 1:N
            for k = 1:N
                d1 = abs(m-j);
                d2 = abs(n-k);
                d1 = min(d1, N-d1);
                d2 = min(d2, N-d2);
                if ((d1^2 + d2^2)^0.5 > Rmin)
                    w1((m-1)*N + n,(j-1)*N +k) = -inh;
                end
            end
        end
    end
end

S = zeros(N,N); %place
for j = 1:N
    for k = 1:floor(N/5)
        S(j, ceil(rand()*N)) = rand();
    end
    for k = 1:floor(N/5)
        S(ceil(rand()*N), j) = rand();
    end
    
end

numStable = 201;
for t = 1:numStable %% let stable pattern form
    S = S + 1./(dtinv+tau) * (-S + max(0., extinp+reshape(w1*S(:), size(S))));
end

Sout = zeros(N*N,len);
for t = dt+1:dt:len-dt
    %% Azimuth/yaw
    ang1 = angs1(t);
    dd1 = ang1-preferencefromsomewhere1;
    dd1(logical(dd1>pi)) = dd1(logical(dd1>pi))-2.*pi;
    dd1(logical(dd1<-pi)) = dd1(logical(dd1<-pi))+2.*pi;
    inp1 = alpha * exp( - dd1.^2 / (2.*varterm));
    %% Pitch
    ang2 = angs2(t);
    dd2 = ang2-preferencefromsomewhere2;
    dd2(logical(dd2>pi)) = dd2(logical(dd2>pi))-2.*pi;
    dd2(logical(dd2<-pi)) = dd2(logical(dd2<-pi))+2.*pi;
    inp2 = alpha * exp( - dd2.^2 / (2.*varterm) );
    
    %% numerically integrate firing rate
    for i = 1:dt
        S = S + 1./(tau+dtinv) * (-S + max(0., extinp + (inp1 + inp2) +  reshape(w1*S(:), size(S))));
    end
    Sout(:,t) = S(:);
end


%

% save('3DData_toroidal', 'Sout', 'posx', 'posy', 'posz', 'angs1', 'angs2', 'angs3');

start = 100;
Sout = Sout(:,dt+1:dt:len-dt);
spikes = FiringRateToSpikes(Sout);
S = SmoothSpikes(spikes);
angs1 = angs1(dt+1:dt:len-dt);
angs2 = angs2(dt+1:dt:len-dt);
angs3 = angs3(dt+1:dt:len-dt);
neurons = 70;%:20:100;
timesteps = 1:1:size(S,2);
figure;
polarplot(angs1(timesteps),S(neurons,timesteps), '*');
figure;
polarplot(angs2(timesteps),S(neurons,timesteps), '*');
