rng('shuffle');
noisevar1 = 0;%0.05;
varterm1 = 0.2;
alpha1 = 0.15;
dt= 10;
inh1 = 0.05;
n = 10;
N = n^2;
extinp = 0.5;
tau = 10;
dtinv = 10;
R = 0.2;
minD = -0.5;
maxD = 0.5;
numholes = 1;
numtimesteps = 3000;
len = 100000;
[posx,posy,posz,roll, pitch, yaw] = GetRandomFlight(minD, maxD, numholes, numtimesteps, len);

preferencefromsomeplacex = zeros(n,n,n);
preferencefromsomeplacey = zeros(n,n,n);
preferencefromsomeplacez = zeros(n,n,n);
for i = 1:n
    for j = 1:n
        for k = 1:n
            preferencefromsomeplacex(i,j,k) = (i-1)'*2*0.5/(n-1) - 0.5 + noisevar1 * normrnd(0,0.5);
            preferencefromsomeplacey(i,j,k) = (j-1)'*2*0.5/(n-1) - 0.5 + noisevar1 * normrnd(0,0.5);
            preferencefromsomeplacez(i,j,k) = (k-1)'*2*0.5/(n-1) - 0.5 + noisevar1 * normrnd(0,0.5);
        end
    end
end

w = zeros(n*n*n,n*n*n);
for j1 = 1:n
    for j2 = 1:n
        for j3 = 1:n
            for i1 = 1:n
                for i2 = 1:n
                    for i3 = 1:n
                        if (((preferencefromsomeplacex(j1,j2,j3)-preferencefromsomeplacex(i1,i2,i.-3))^2 ...
                                +(preferencefromsomeplacey(j1,j2,j3)-preferencefromsomeplacey(i1,i2,i3))^2 ...
                                +(preferencefromsomeplacez(j1,j2,j3)-preferencefromsomeplacez(i1,i2,i3))^2)^0.5 > R)
                            w((j1-1)*n*n + (j2-1)*n+j3,(i1-1)*n*n+(i2-1)*n+i3) = -inh1;
                        end
                    end
                end
            end
        end
    end
end

S1 = zeros(n,n,n); %place

for j = 1:n
    for k = 1:n
        for i = 1:floor(n/5)
            S1(ceil(rand()*n), j, k) = rand();
        end
        for i = 1:floor(n/5)
            S1(j, ceil(rand()*n), k) = rand();
        end
        for i = 1:floor(n/5)
            S1(j,k, ceil(rand()*n)) = rand();
        end
    end
end

numStable = 200;
for t = 1:numStable %% let stable pattern form
    S1 = S1 + 1./(tau) * (-S1 + max(0., extinp+reshape(w*S1(:), size(S1))));
end

len = length(posx);
SoutP = zeros(n*n*n,len);
angP = zeros(len, 1);
for t = dt+1:length(posx)-dt
    ang = atan2((posy(t+dt)-posy(t-dt)),(posx(t+dt)- posx(t-dt)));
    angP(t,:) = ang;
    %      v = ((posy(t+dt)-posy(t-dt))^2+(posx(t+dt)- posx(t-dt))^2)^0.5/(2*dt/1000);
    
    %% place cells
    dpx = (posx(t)-preferencefromsomeplacex).^2;
    dpy = (posy(t)-preferencefromsomeplacey).^2;
    dpz = (posz(t)-preferencefromsomeplacez).^2;
    inp1 = zeros(n,n,n);
    for i = 1:n
        for j = 1:n
            for k = 1:n
                if ((dpx(i,j,k) + dpy(i,j,k) + dpz(i,j,k))^2 < 2*R)
                    inp1(i,j,k) = alpha1*exp( - (dpx(i,j,k) + dpy(i,j,k) + dpz(i,j,k))/ (varterm1) );
                end
            end
        end
    end
    %% numerically integrate firing rate
    for i = 1:dt
        S1 = S1 + 1./(tau) * (-S1 + max(0., extinp +  inp1 + reshape(w*S1(:), size(S1))));
    end
    SoutP(:,t) = S1(:);
end


SoutP = SoutP(:,1:t);
posx = posx(1:t);
posy = posy(1:t);
posz = posz(1:t);
scatter3(posx,posy,posz, [], SoutP(1,:));

spikes = FiringRateToSpikes(SoutP);
S = SmoothSpikes(spikes);

time = 1:1:t;
figure
scatter3(posx(time),posy(time),posz(time), [], S(710,time));

