function [x,y, angs] = GetRandomWalk(min, max, numholes, numtimesteps,len)
x = zeros(numtimesteps,1);
y = zeros(numtimesteps,1);
maxlen = abs(max-min);
holes = [];%zeros(numholes, 2);
r = 0.25;

x(1:2) = ones(2,1)*rand()*maxlen-maxlen/2;
y(1:2) = ones(2,1)*rand()*maxlen-maxlen/2;
if (numholes > 0)
    if (numholes== 4)
        del = (max-min)/4;
        holes = [del del; del -del; -del del; -del -del];
    elseif(numholes == 1)
        holes = [0 0];
    end
    
    while(find((((holes(:,1) - x(1)).^2 +(holes(:,2) - y(1)).^2).^0.5) < r))
        x(1) = rand()-0.5;
        y(1) = rand()-0.5;
    end
end
v = 0.1;
stddev = 0.05*v;
for i = 3:numtimesteps
    newstep = false;
    while (~newstep)
        dX= [x(i-1)-x(i-2); y(i-1)-y(i-2)];
        dir = [normrnd(dX(1), 0.1); normrnd(dX(2), 0.1)];
        if (dir~=0)
            dir = dir.*normrnd(v,stddev)/norm(dir);
        else
            dir = [0.0001*(rand()-0.5), 0.0001*(rand()-0.5)];
        end
        tempx = x(i-1) + dir(1);
        tempy = y(i-1) + dir(2);
        if(tempx > 0.99*max || tempx < 1.01*min || tempy > 0.99*max || tempy < 1.01*min)
            continue;
        elseif(~isempty(holes))
            if  (find((((holes(:,1) - tempx).^2 +(holes(:,2) - tempy).^2).^0.5) < 1.01*r))
                continue;
            end
        end
        newstep = true;
    end
    x(i) = tempx;
    y(i) = tempy;
end


W = cscvn([x y]');
stop = numtimesteps/3;
start = 1;
dt = (stop-start)/(len-1);
u = ppval(W, start:dt:stop);
x = u(1,1:end);
y = u(2,1:end);
yaw = zeros(1,len);
dt = 10;
angs(1:10) = ones(1,10)*(rand()-0.5)*2*pi;
for t = 1+dt:1:len-dt
    dx = x(t+dt) - x(t-dt);%mean(x(t:t+dt))- mean(x(t-dt:t));
    dy = y(t+dt) - y(t-dt);%mean(y(t:t+dt))- mean(y(t-dt:t));
    angs(t) = angle(dx + 1i*dy);
    if(angs(t)>pi)
        angs(t) = angs(t)-2.*pi;
    elseif(angs(t)<-pi)
        angs(t) = angs(t)+2.*pi;
    end
end
end
