rng('shuffle');
noisevar = 0.2;
varterm= 0.3;
alpha = 0.3;
dt= 10;
N = 100;
Rmin = 30;
R = 3;
inh = 0.05;
n = 10;
extinp = 1;
rint3 = randi(N-1);
% rint2 = randi(N-1);
dtinv = 10;
tau = 10;

A = load('animal_movement.mat');
posx = A.posx;
posy = A.posy;

xes = zeros(N, 1);
for x = 1:N
    xes(x) = x;
end
W = zeros(N,N);
for x = 1:N
    xdiff = abs(xes-x);
    xdiff = min(xdiff, N-xdiff);
    W(x,xdiff>Rmin) = -inh;
end

S = zeros(N,1); %Usual HD
S3 = zeros(N,1); %Second Head

for i = 1:floor(N/3)
    S(ceil(rand()*(N))) = rand();
    S3(ceil(rand()*(N))) = rand();
end

numStable = 201;
F1(floor(numStable/2)) = struct('cdata',[],'colormap',[]);
for t = 1:numStable %% let stable pattern form
    S = S + 1./(dtinv+tau) * (-S + max(0., extinp+W*S));
    S3 = S3 + 1./(dtinv+tau) * (-S3 + max(0., extinp+W*S3));
end
% inputs on [-pi, pi) + noisevar
preferencefromsomewhere = (1:N)'*2*pi/(N-1) - pi  + noisevar * normrnd(0,pi, N,1);
% preferencefromsomewhere2 = preferencefromsomewhere;
preferencefromsomewhere2 = (1:N)'*2*pi/(N-1) - pi  + noisevar * normrnd(0,pi, N,1);
% preferencefromsomewhere2 = [preferencefromsomewhere2(rint3+1:N,1); preferencefromsomewhere2(1:rint3,1)];

% len = length(posx);

len = 100000;
Sout = zeros(N,len);
Sout3 = zeros(N,len);
angs1 = zeros(len, 1);
angs2 = zeros(len, 1);
endmovietime = 5000;
F2(floor(endmovietime/10)) = struct('cdata',[],'colormap',[]);

ang1 = 2*pi*rand()-pi;
ang2 = ang1 + pi;
if (ang2>pi )
    ang2 = ang2 -2*pi;
end
for t = dt+1:len
    %% Angles 1
    %% ang1
%         ang1 = atan2((posy(t+dt)-posy(t-dt)),(posx(t+dt)- posx(t-dt)));
    %% ang2
%     ang1 = ang1 + 0.1;
    %% ang3
    %     ang1 = ang1 + 0.1;
    %% ang4
%         ang1 = ang1 + rand()*0.1;
    %% ang5
%         ang1 = ang1 + pi/8*(normrnd(0,0.1));
    %% ang6
    ang = atan2((posy(t+dt)-posy(t-dt)),(posx(t+dt)- posx(t-dt)));
    angtemp1 = (ang+pi)-(ang1+pi);
    if (angtemp1 >pi)
        angtemp1 = -(angtemp1 - pi);
    elseif (angtemp1 <-pi) 
        angtemp1 = -(angtemp1 + pi);
    end
    ang1 = normrnd(ang1,pi/12) + normrnd(angtemp1,0.02) ;
     %% Head 1
    dd = ang1-preferencefromsomewhere;
    if(sum(dd>pi)>0)
        dd(dd>pi) = dd(dd>pi)-2.*pi;
    end
    if(sum(dd<-pi)>0)
        dd(dd<-pi) = dd(dd<-pi)+2.*pi;
    end
    inp = alpha * exp( - dd.^2 / (2.*varterm) );

    if (ang1>pi )
        ang1 = ang1 -2*pi;
    elseif (ang1 < -pi)
        ang1 = ang1 + 2*pi;
    end
    angs1(t,:) = ang1;
    
    %% Angles 2
    %% ang1
%         ang2 = atan2((posy(t+dt+len)-posy(t-dt+len)),(posx(t+dt+len)- posx(t-dt+len))); 
    %% ang2
%         ang2 = ang2 + 0.1;
    %% ang3
%         ang2 = ang2 - 0.1;
    %% ang4
%         ang2 = ang2 - rand()*0.05;
    %% ang5
%         ang2 = ang2 + pi/8*(normrnd(0,0.1));
    %% ang6
        angtemp2 = ang+ pi;
        if (angtemp2 > pi)
            angtemp2 = angtemp2-2*pi;
        end
        angtemp2 = (angtemp2+pi) -(ang2 +pi);
        if (angtemp2 >pi)
            angtemp2 = -(angtemp2 - pi);
        elseif (angtemp2 <-pi)
            angtemp2 = -(angtemp2 + pi);
        end
        ang2 = normrnd(ang2,pi/12) + normrnd(angtemp2,0.02) ;
    
    if (ang2>pi )
        ang2 = ang2 -2*pi;
    elseif (ang2 < -pi)
        ang2 = ang2 + 2*pi;
    end    
    angs2(t,:) = ang2;
    %% Second Head
    dd2 = ang2-preferencefromsomewhere2;
    if(sum(dd2>pi)>0)
        dd2(dd2>pi) = dd2(dd2>pi)-2.*pi;
    end
    if(sum(dd2<-pi)>0)
        dd2(dd2<-pi) = dd2(dd2<-pi)+2.*pi;
    end
    inp3 = alpha * exp( - dd2.^2 / (2.*varterm) ); 
    for i = 1:dt
        S = S + 1./(dtinv+tau) * (-S + max(0., extinp + inp +  W*S));
        S3 = S3 + 1./(dtinv+tau) * (-S3 + max(0., extinp + inp3 + W*S3));
    end
    Sout(:,t) = S(:);
    Sout3(:,t) = S3(:);
end

spikes = FiringRateToSpikes(Sout);
S = SmoothSpikes(spikes);
spikes3 = FiringRateToSpikes(Sout3);
S3 = SmoothSpikes(spikes3);

save('TwoHeadedDataplusRndCase6', 'S', 'S3', 'angs1', 'angs2');

neurons = 1;%:20:100;
timesteps = 1:50:100000;%size(Sout,2);
figure;
polarplot(angs1(timesteps),S(33,timesteps), '*');
figure;
polarplot(angs2(timesteps),S3(33,timesteps), '*');